#include "as.h"

#define version         "Assembler 1.0"
#define usage           "Usage: ASSEMBLE source [listing]\n"

void main(int argc, char *argv[])
{ bool errors;
  char sourcename[256], listname[256], objname[256];

  // check on correct parameter usage
  if (argc == 1) { printf(usage); exit(1); }
  strcpy(sourcename, argv[1]);
  if (argc > 2) strcpy(listname, argv[2]);
  else 
  {
	  appendextension(sourcename, ".lst", listname);
	  appendextension(sourcename, ".obj", objname);
  }

  AS *Assembler = new AS(sourcename, listname, version, objname);
  Assembler->assemble(errors);
  if (errors)
  { printf("\nAssembly failed\n"); }
  else
  { printf("\nAssembly successful\n");
  }
  delete Assembler;
}
