#include "st.h"

void ST::printsymboltable(bool &errors)
{ fprintf(Srce->lst, "\nSymbol Table\n");
  fprintf(Srce->lst, "------------\n");
  ST_entries *symentry = lastsym;
  while (symentry)
  { Srce->writetext(symentry->name, 10);
    if (!symentry->defined)
    { fprintf(Srce->lst, " --- undefined"); errors = true; }
    else
    { 
		fprintf(Srce->lst, "%s PTR ", (symentry->dsize==DS_BYTE)?" BYTE":((symentry->dsize==DS_BYTE)?" WORD":"DWORD"));
        fprintf(Srce->lst, "%08x", symentry->value);
    }
	ST_forwardrefs *link = symentry->flink;
	fprintf(Srce->lst, "\tFLINK:");
    while (link)
    { fprintf(Srce->lst, " %04x", link->patch );
      link = link->nlink;
    }
    putc('\n', Srce->lst);
    symentry = symentry->slink;
  }
  putc('\n', Srce->lst);
}

void ST::findentry(ST_entries *&symentry, char *name, bool &found)
{ symentry = lastsym;
  found = false;
  while (!found && symentry)
  { if (!strcmp(name, symentry->name))
      found = true;
    else
      symentry = symentry->slink;
  }
  if (found) return;
  symentry = new ST_entries;  // make new forward reference entry
  sprintf(symentry->name, "%.*s", ASM_alength, name);
  symentry->value = 0;
  symentry->dsize = DS_DWORD;
  symentry->defined = false;
  symentry->flink = NULL;
  symentry->slink = lastsym;
  lastsym = symentry;
}

void ST::enter(char *name, int value, DATA_SIZE ds)
{ ST_entries *symentry;
  bool found;
  findentry(symentry,name,found);
  symentry->value = value;
  symentry->dsize = ds;
  symentry->defined = true;
}

void ST::valueofsymbol(char *name, int location, int &value, DATA_SIZE &ds,
                      bool &undefined)
{ ST_entries *symentry;
  ST_forwardrefs *forwardentry;
  bool found;
  findentry(symentry, name, found);
  value = symentry->value;
  ds = symentry->dsize;
  undefined = !symentry->defined;
  if (!undefined) return;
  forwardentry = new ST_forwardrefs; // new node in reference chain
  forwardentry->patch = location;
  if (found)                         // it was already in the table
    forwardentry->nlink = symentry->flink;
  else                               // new entry in the table
    forwardentry->nlink = NULL;
  symentry->flink = forwardentry;
}

void ST::outstandingreferences(unsigned char mem[], ST_patch fix)
{ ST_forwardrefs *link;
  ST_entries *symentry = lastsym;
  while (symentry)
  { link = symentry->flink;
    while (link)
    { fix(mem, link->patch, symentry->value);
      link = link->nlink;
    }
    symentry = symentry->slink;
  }
}

ST::ST(SH *S)
{ Srce = S; lastsym = NULL; }
